/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated 
 * by the @authors tag. All rights reserved. 
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors. 
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package org.jboss.soa.esb.samples.quickstart.simplecbr;

import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.message.Body;

public class MyJMSListenerAction extends AbstractActionLifecycle
{
    
  protected ConfigTree	_config;
	  
  public MyJMSListenerAction(ConfigTree config) { _config = config; } 
  
  public Message noOperation(Message message) { return message; } 

  public Message arrangeMessage(Message message) throws Exception{		
	  logHeader();
	  Object order = message.getBody().remove(Body.DEFAULT_LOCATION);
	  //Object order = message.getBody().get(Body.DEFAULT_LOCATION);
	  message.getBody().add( "user.ntfn.order", order );
	  System.out.println("MyJMSListenerAction.displayMsg: Body [default]: " + message.getBody().get());
	  System.out.println("MyJMSListenerAction.displayMsg: Body ['user.ntfn.order']: " + message.getBody().get("user.ntfn.order"));
	  System.out.println("MyJMSListenerAction.displayMsg: Body ['user.ntfn.profile']: " + message.getBody().get("user.ntfn.profile"));
	  logFooter();
	  return message;
  }

  public Message displayMessage(Message message) throws Exception{		
		  logHeader();
		  //System.out.println("Body: " + message.getBody().get());
		  // -------------------------------------------
		  // -=j=-: ok, let's rearrange this, rm the profile from default,
		  // put the order back in default, leave all named loc's as they are
		  Object foo = message.getBody().remove(Body.DEFAULT_LOCATION);
		  message.getBody().add( message.getBody().get("user.ntfn.order") );
		  System.out.println("MyJMSListenerAction.displayMsg: Body [default]: " + message.getBody().get());
		  System.out.println("MyJMSListenerAction.displayMsg: Body ['user.ntfn.order']: " + message.getBody().get("user.ntfn.order"));
		  System.out.println("MyJMSListenerAction.displayMsg: Body ['user.ntfn.profile']: " + message.getBody().get("user.ntfn.profile"));
		  logFooter();
		  return message;
	}
  
   public void exceptionHandler(Message message, Throwable exception) {
	   logHeader();
	   System.out.println("!ERROR!");
	   System.out.println(exception.getMessage());
	   System.out.println("For Message: ");
	   System.out.println(message.getBody().get());
	   logFooter();
   }
	

   // This makes it easier to read on the console
   private void logHeader() {
	   System.out.println("\n&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&MyJMSListenerAction");
   }
   private void logFooter() {
	   System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&MyJMSListenerAction\n");
   }
    
	
}